<?php

namespace FM\Controller;

use FM\Service\FmtProdutoService;
use FM\Traits\TResponse;

class FmtProdutoController
{
    use TResponse;

    protected $ProdutoService;

    public function __construct(FmtProdutoService $ProdutoService)
    {
        $this->ProdutoService = $ProdutoService;
    }

    public function produtos()
    {
        try {
            $data = $this->ProdutoService->getProdutos();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
