<?php

namespace FM\Service;

use FM\Factory\RelatoriosTarefasFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use FM\Service\FuncionariosHierarqService;

class RelatoriosTarefasService
{

    protected $RelatoriosTarefasFactory;
    protected $FuncionariosHierarqService;
    protected $Environment;
    protected $newCode;

    public function __construct(RelatoriosTarefasFactory $RelatoriosTarefasFactory, FuncionariosHierarqService $FuncionariosHierarqService, Environment $Environment, NewCode $newCode)
    {
        $this->RelatoriosTarefasFactory     = $RelatoriosTarefasFactory;
        $this->FuncionariosHierarqService   = $FuncionariosHierarqService;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }

    public function getDashRelatorioTarefas()
    {

        $cdoperador = $this->Environment->getCdOperador();
        $listaOperadores = $this->FuncionariosHierarqService->montarHierarquiaOperadores($cdoperador);

        $params = array(
            "CDOPERADOR" => $cdoperador
        );

        return $this->RelatoriosTarefasFactory->getDashRelatorioTarefas($params, $listaOperadores);
        
        
        // foreach ($dados as $tarefas) {
        //     foreach ($tarefas as $key => $value) {
        //         debugApi($value[$key]);
        //     }

        //     $atraso = $this->calcularAtraso($tarefa['DTHORAAGEND']);
        // }
    }

    // public function calcularAtraso($dataTarefa)
    // {
    //     $dataAtual = new \DateTime(); // Obtém a data e hora atual
      
    //     $dataTarefa = \DateTime::createFromFormat('d/m/Y H:i', $dataTarefa); // Converte a string da data da tarefa em um objeto DateTime
      
    //     // Calcula a diferença entre a data atual e a data da tarefa
    //     $diferenca = $dataAtual->diff($dataTarefa);
      
    //     // Obtém o número de dias e horas de atraso
    //     $diasAtraso = $diferenca->days;
    //     $horasAtraso = $diferenca->h;
      
    //     // Retorna o atraso em dias e horas
    //     return "Atraso: {$diasAtraso} dia(s) e {$horasAtraso} hora(s)";
    // }
    
    public function getRelatoriosTarefas()
    {
        $cdoperador = $this->Environment->getCdOperador();
        $listaOperadores = $this->FuncionariosHierarqService->montarHierarquiaOperadores($cdoperador);

        $params = array(
            "CDOPERADOR" => $cdoperador
        );

        return $this->RelatoriosTarefasFactory->getRelatoriosTarefas($params, $listaOperadores);
    }

    public function getItensTarefas($parametros)
    {
        return $this->RelatoriosTarefasFactory->getItensTarefas($parametros['NRCHECKLISTAGEND']);
    }

    public function getFotosTarefas($parametros)
    {
        return $this->RelatoriosTarefasFactory->getFotosTarefas($parametros['NRCHECKLISTAGEND']);
    }

    public function getFiltroRelatorioLocal()
    {
        $listaLocais = $this->FuncionariosHierarqService->getLocaisHierarquia($this->Environment->getCdOperador());
        return $this->RelatoriosTarefasFactory->getFiltroRelatorioLocal($listaLocais);
    }

    public function getFiltroRelatorioChecklist()
    {
        return $this->RelatoriosTarefasFactory->getFiltroRelatorioChecklist();
    }

    public function getFiltroRelatorioCliente()
    {
        return $this->RelatoriosTarefasFactory->getFiltroRelatorioCliente();
    }
}
